var UI = (function($, JET, User, LocationService, win) {

	var isIntialised = false,

		navTransitionAmount,

		// jQuery Object Cache
		$app,
		$main,
		$mainBody,
		$searchBar,
		$title,
		$backsearch,
		$navList,
		$modal,
		$modalTitle,
		$modalPrimaryButton,
		$modalSecondaryButton,
		$modalBody,

		// Der aktuell angezeigte Controller
		currentController,

		// UI State
		state = new machina.Fsm({

			states: {

				// Begin
				uninitialized: {

					'initialize': function() {

						navTransitionAmount = window.innerWidth - 44;

						$app = $('#app');
						$main = $('#main');
						$mainBody = $('#main-body');
						$searchBar = $('#searchbar');
						$title = $('#main-title');
						$backsearch = $('#back-search');
						$navList = $('#nav ul');

						$modal = $('#modal');
						$modalTitle = $('#modal-title');
						$modalPrimaryButton = $('#modal-primary');
						$modalSecondaryButton = $('#modal-secondary');
						$modalBody = $('#modal-body');

						if(User.isLoggedIn()) {
							$app.removeClass('log-out').addClass('log-in');
						} else {
							$app.removeClass('log-in').addClass('log-out');
						}

						bindUIEvents();

						isIntialised = true;
						showInitialView();

						

						this.transition('idle');

					}

				},

				// Nix los
				idle: {
					_onEnter: function() {
						//console.log('UI is idle');
						JET.trigger('UI.idle');
					},

					'click.search': 'search_open',
					'click.nav': 'nav_open',
					'show.back': 'back',
					'click.back': function() {
						if(isAndroid()) {
							if(Radar.status() == 'enabled') {

								UI.alert(
									{
										body: '<b>JET App inkl. Tankstellenradar beenden?</b><br />Sonst bitte "Fenster schließen" und "Home-Taste" drücken.',
										okbutton: 'App beenden',
										cancelbutton: 'Fenster schließen'
									},
									function() {
										Radar.disable();
										navigator.app.exitApp();		
									}
								);

							} else {
								navigator.app.exitApp();
							}
							
						}
					}
				},

				// Navigation auf
				nav_open: {
					_onEnter: function() {
						//console.log('UI is in Navmode');

						//Open Nav
						openNav();

					},
					_onExit: function() {
						//Close Nav
						closeNav();
						JET.trigger('UI.nav.close');
					},
					'click.back': 'idle',
					'click.nav': 'idle',
					'click.nav.item': function(controller, type) {
						
						if(type == 'show') {
							show(controller);
						
						} else {
							modal(controller);

						}
						this.transition('idle');
						
					},
					'*': function() {
						this.deferUntilTransition();
					}
				},

				// Ein View zeigt einen Subview an
				back: {
					_onEnter: function() {
						console.info('UI is in Backmode');

						// Show Back Button Icon
						$backsearch.addClass('is-back').removeClass('is-search');

						JET.trigger('UI.back.enter');

					},
					_onExit: function() {
						//$backsearch.addClass('is-search').removeClass('is-back');
						console.info('UI is no longer in Backmode');
						JET.trigger('UI.back.exit');

					},
					'click.nav': 'nav_open_back',
					'click.back': function() {
						
						JET.trigger('UI.back.click');
					},
					'hide.back': function() {
						$backsearch.addClass('is-search').removeClass('is-back');
						this.transition('idle');
					}
				},

				// Ein View zeigt einen Subview an und das Menü wird geöffnet
				nav_open_back: {
					_onEnter: function() {
						//console.log('UI is in Navmode & Back');

						//Open Nav
						openNav();
					},
					_onExit: function() {
						// Close Nav
						closeNav();
					},
					'click.nav': 'back',
					'click.nav.item': function(controller, type) {


						if(type == 'show') {
							// Neue Seite soll angezeigt werden
							// Verberge Backbutton
							$backsearch.addClass('is-search').removeClass('is-back');
							show(controller);
							this.transition('idle');
						} else {
							// Neue Seite soll als Modal angezeigt werden
							modal(controller);
							this.transition('back');
						}

					},
					'*': function() {
						this.deferUntilTransition();
					}
				},

				// Suchleiste ist geöffnet
				search_open: {
					_onEnter: function() {
						//console.log('UI is in Searchmode');

						// Open SearchBox
						$searchBar.addClass('is-open');
						//$('#q').focus();

					},
					_onExit: function() {
						// Close SearchBox
						$searchBar.removeClass('is-open');
						$('#q').blur();

					},
					'click.nav': 'nav_open',
					'click.search': 'idle',
					'show.back': 'back',
					'search.location': function() {

						// User möchte seine aktuelle Position ermitteln

						// Wir warten mit der Geolocationabfrage, bis die Seite "Tankstellensuche" bereit ist
						JET.one('tssuche.isReady', function() {
							setTimeout(function() {
								LocationService.locate();
							}, 400);
						});

						// Zeige Tankstellesuche
						show('Tankstellensuche', 'locating');

						this.transition('idle');

					},
					'search.address': function(string) {

						// User möchte seine Suchbegriff Geocodieren lassen

						// Wir warten mit der Geocodingabfrage, bis die Seite "Tankstellensuche" bereit ist
						JET.one('tssuche.isReady', function() {
							setTimeout(function() {
								LocationService.search(string);
							}, 400);
						});

						// Zeige Tankstellensuche
						show('Tankstellensuche', 'searching');

						this.transition('idle');

					}
				},

				modal: {},

				alert: {}


			}

		});


	JET.on('app.ready', function() {

		state.handle('initialize');

	});


	function bindUIEvents() {

		// Suche Button
		$main.on('click', '#back-search.is-search', handleSearch);
		// Android Suche Button
		win.document.addEventListener("searchbutton", handleSearch, false);

		// Back Button
		$main.on('click', '#back-search.is-back', handleBack);
		// Android Back Button
		win.document.addEventListener("backbutton", handleBack, false);
		
		// Menu Button
		$('#toggle-nav').on('click', handleNavToggle);
		// Android Menu Button
		win.document.addEventListener("menubutton", handleNavToggle, false);

		$navList.on('click', '[data-page="Tankstellenradar"] button', function(e) {
			e.preventDefault();
			e.stopPropagation();

			if(Radar.status() == 'enabled') {
				Radar.disable();
			} else {
				Radar.enable();
			}

		});
		
		setTimeout(function() {
			
			if(Radar.status() == 'enabled') {
				Radar.enable();
			} else {
				Radar.disable();
			};

		}, 400);

		// Menuelement ausgewählt.
		$navList.on('click', 'li', function(e) {

			e.preventDefault();

			var controller, type, $li;
			if(this.hasAttribute('data-page')) {

				$li = $(this);
				if($li.hasClass('is-active')) {
					return handleNavToggle(e);
				}

				controller = this.getAttribute('data-page');
				type = 'show';

			} else {
				controller = this.getAttribute('data-modal');
				type = 'modal';
			}

			state.handle('click.nav.item', controller, type);
		});

		var $q = $('#q');

		$searchBar.on('submit', function(e) {
			e.preventDefault();

			var searchValue = $q.val();
			if(searchValue == '') {

				$q.focus();

			} else {

				state.handle('search.address', searchValue);
				$q.blur();

			}

		}).on('click', '#locate', function(e) {
			
			e.preventDefault();
			state.handle('search.location');
			return false;

		});

		
		$modalPrimaryButton.on('click', function(e) {

			JET.trigger('modal.primary.click');

		});
		$modalSecondaryButton.on('click', function(e) {

			modalClose();

			JET.trigger('modal.secondary.click');

		});


		// Login/Register Buttons nicht eingeloggt
		$main.on('click', '.loginregister button[data-modal]', function(e) {
			e.preventDefault();

			UI.modal(this.getAttribute('data-modal'));

		});


		JET.on('localnotification.click', function(e, id, state, json) {


			var data = json && JSON.parse(json) || {};
			/* API hat sich geändert, json ist kein JSON mehr..
			var data = json;
			*/
			if(data['type'] == 'radar') {
				UI.show('Tankstellensuche', {
					station_number: data['id'],
					lat: data['lat'],
					lng: data['lng']
				});
				UI.closeNav();
			} else if(data['type'] == 'radarerror') {
				UI.alert({
					body:data['msg'],
					okbutton: 'OK',
					cancelbutton:'Radar beenden'
				}, function() {
					// noop
				}, function() {
					Radar.disable();
				});
			}

		});

		if(localStorage.getItem('iospushtoken') || localStorage.getItem('gcmpushtoken')) {
			JET.registerPush();
		}

	};

	/**
	 * Callbackfunction für den Suchbutton
	 * @param e
	 */
	function handleSearch(e) {
		e.preventDefault();
		state.handle('click.search');
	}

	/**
	 * Callbackfunction für den Backbutton
	 * @param e
	 */
	function handleBack(e) {
		e.preventDefault();

		if($app.hasClass('modal-show')) {
			modalClose();

			JET.trigger('modal.secondary.click');
			return;
		}
		state.handle('click.back');
	}

	/**
	 * Callbackfunction für den Menübutton
	 * @param e
	 */
	function handleNavToggle(e) {
		e.preventDefault();

		if($app.hasClass('modal-show') || $app.hasClass('show-alert')) {
			return;
		}

		state.handle('click.nav');
	}

	/**
	 * Öffnet die Navigation
	 */
	function openNav() {
		$app.addClass('showMenu');
		$navList[0].scrollTop=0;
		setTimeout(function() {
			$main.css('transform', 'translate3d(-' + (window.innerWidth - 44) + 'px, 0, 0)');
		}, 10);

	};

	/**
	 * Schliesst die Navigation
	 */
	function closeNav() {
		$app.removeClass('showMenu');
		$main.css('transform', '');
	};

	var initialView = null;

	function showInitialView() {


		JET.one('view.didAppear', function() {

			setTimeout(function() {

				$mainBody.removeClass('is-loading');

			}, 1000);

		});

		if(initialView) {
			show(initialView[0], initialView[1]);
			initialView = null;
			return;
		}

		show(User.isLoggedIn() ? 'Preisalarm' : 'Startseite');

	};


	function show(which, args) {

		if(!isIntialised) {
			initialView = [which, args];
			return;
		}

		$navList.find('.is-active').removeClass('is-active');
		$navList.find('li[data-page="'+which+'"]').addClass('is-active');

		// Check for restricted Views
		if(!User.isLoggedIn()) {

			switch(which) {
				case 'Preisalarm':
				case 'Boxenstopp':
				case 'Termine':
				case 'Klicke':
				case 'Profil':
				case 'Einstellungen':
					which += 'NoLogin';
				break;
			}

		}

	//	console.log('UI.show %s', which, args);

		var nextController = JET.getController(which), nextView;

		if(currentController == nextController) {

			if(which == 'Tankstellensuche' && args) {
				//JET.trigger('station.detail', [args]);
				currentController.viewWillAppear(args);
			}

			JET.trigger('view.didAppear', which);
			currentController.viewDidAppear();
			nextController = null;
			return;
		}

		nextController.viewWillAppear(args);
		currentController && currentController.viewWillDisappear();

		$title.html(nextController.getTitle());

		nextView = nextController.getView();

		nextView.toggleClass('active hidden');

		nextController.viewDidAppear();

		currentController && currentController.viewDidDisappear();

		currentController = nextController;

		JET.trigger('view.didAppear', which);

	};

	var modalController;
	function modal(which, args) {

	//	console.log('UI.modal %s', which);

		var modalView;

		if($app.hasClass('modal-show')) {
			modalClose().done(function() {
				modal(which, args);
			});
			return;
		}

		$modalPrimaryButton.removeClass().text('OK').show();
		$modalSecondaryButton.removeClass().text('Abbrechen').show();

		modalController = JET.getController(which);
		modalController.viewWillAppear(args);
		modalView = modalController.getView();

		$modalTitle.html(modalController.getTitle());

		$modalBody.html(modalView);
		$app.addClass('modal-show');
		modalView.toggleClass('hidden active');

		setTimeout(function() {

			modalController.viewDidAppear();
			JET.trigger('modal.didAppear', which);

		}, 300);


	};
	function modalClose(pleaseRefreshTheCurentView) {
		
		var deferred = $.Deferred();

		modalController.viewWillDisappear();

		$app.removeClass('modal-show');

		setTimeout(function() {
			modalController.viewDidDisappear();
			modalController = null;

			pleaseRefreshTheCurentView && currentController.refresh();

			deferred.resolve();

		}, 400);


		return deferred.promise();

	};

	function alert(content, okcallback, cancelcallback) {
	//	console.log('UI.alert');

		var alertContent = {
			body: '',
			okbutton: 'OK',
			cancelbutton: false
		}, promise;

		if(!_.isObject(content)) {
			alertContent.body = content;
		} else {
			alertContent = $.extend({}, alertContent, content);
		}

		if(cancelcallback && !alertContent.cancelbutton) {
			alertContent.cancelbutton = true;
		}


		$.when(_alert(alertContent)).then(okcallback, cancelcallback);

	};

	function _alert(content) {

		var defer = $.Deferred(), cancelButtonText;
		defer.always(function() {
			$('#alert-wrapper').off('.overlay');
			$app.removeClass('show-alert');
		});

		$('#alert-body').html(content.body);
		$('#alert-ok').html(content.okbutton || 'OK');

		if(content.cancelbutton) {
			if(content.cancelbutton === true) {
				cancelButtonText = 'Abbrechen';
			} else {
				cancelButtonText = content.cancelbutton;
			}
			$('#alert-cancel').html(cancelButtonText).show();
			$('#alert-ok').css('width', '50%');
		} else {
			$('#alert-cancel').hide();
			$('#alert-ok').css('width', '100%');
		}

		$('#alert-buttons').one('click', 'button', function(e) {
			e.preventDefault();

			if(this.id == 'alert-ok') {
				defer.resolve();
			} else {
				defer.reject();
			}

		});
		$('#alert-wrapper').on('*.overlay', function(e) {
			e.preventDefault();
			e.stopImmediatePropagation();
		});

		$app.addClass('show-alert');

		return defer.promise();

	}

	function setTitle(title) {
		$title.html(title);
	}

	return {

		closeNav: function() {
			closeNav();
			state.transition('idle');
		},
		show: show,
		modal: modal,
		modalClose: modalClose,
		alert: alert,
		handle: function(msg, args) {
			state.handle(msg, args);
		},
		setTitle: setTitle,
		toggleLoading: function() {
			$app.toggleClass('show-loading');
		},
		state: state

	};


}(jQuery, JET, User, LocationService, window));