var User = (function($) {

	var authToken = '', 
		data = {};

	/**
	 * Setzt Userdaten
	 */
	function setData(key, value) {

		if(typeof value === "undefined") {
			// Set everything		
			data = key;
			
			
			// Bugfix
			// Hier wurde nur nach if(key['token']) geschaut. Das schlug aber fehl, wenn der Token leer ist...
			if(typeof key['token'] !== 'undefined') {
				setToken(key.token+'');
			}
			
		} else {
			// Setzte einzelnen Wert
			data[key] = value;
		}

		// Aktualisiere localstorage
		localStorage['iospushtoken'] = data['ios_token'] || '';
		localStorage['gcmpushtoken'] = data['gcm_token'] || '';

	}

	/**
	 * Gibt die Userdaten zurück
	 * @param key
	 * @returns {*}
	 */
	function getData(key) {
		return key ? data[key] : data;
	}

	/**
	 * User eingeloggt?
	 * @returns {boolean}
	 */
	function isLoggedIn() {
		return !(getToken() === '');
	}

	/**
	 * Gibt das Logintoken zurück
	 * @returns {string}
	 */
	function getToken() {
		if(authToken === '') {

			authToken = window.localStorage['jet.app.authToken'] || '';

		}

		return authToken;
	}

	/**
	 * Setzt das Logintoken
	 * @param token
	 */
	function setToken(token) {
		window.localStorage['jet.app.authToken'] = authToken = token;

		if(token === '') {
			$('#app').removeClass('log-in').addClass('log-out');
		} else {
			$('#app').removeClass('log-out').addClass('log-in');
		}
	}

	/**
	 * Lädt die Benutzerdaten vom Server
	 * @returns jQuery.promise
	 */
	function update() {

		console.log('Updating User');

		var deferred = $.Deferred();

		if(!isLoggedIn()) {

			console.log('User not logged in :-(');

			deferred.resolve();
		} else {

			console.log('Loading User');

			$.post(JET.backendURL, {
				action: 'getUserData',
				token: getToken()
			}).done(function(data) {

				console.log('Userdata %o', data);
				setData(data.user);

				deferred.resolve();

			}).fail(function(jqXHR) {

				if(isOfflineError(jqXHR)) {
					JET.one('app.ready', function() {
						displayNoConnectionError(true);
					});
				} else {
					setData('');
					setToken('');	
				}


				deferred.reject(jqXHR);
				
			}).always(function() {
				
			})

		}

		return deferred.promise();

	};



	return {

		update: update,

		setData: setData,
		getData: getData,

		isLoggedIn: isLoggedIn,

		getToken: getToken,
		setToken: setToken

	};

})(jQuery);