JET.controller('Einstellungen', function(el) {

	var isTemplateLoaded = false;

	var config = {
		title: 'Einstellungen',
		template: 'Einstellungen.html',
		templateLoaded: function() {
			isTemplateLoaded = true;
			render();
		},
		viewWillAppear: function() {

			// Buttontext für den Modalbutton rechts
			$('#modal-primary').text('Speichern');
			// Verberge "Abbrechen"-Button
			//$('#modal-secondary').hide();

			if(isTemplateLoaded) {
				render();
			}
		},
		bindEvents: function() {

			// Eventhandler, der bei jeder Änderung einer Option aufgerufen wird.
			el.on('change.settings', 'input', function() {
				
				var that = this;

				// API Parameter
				var params = {
					action:'changeSettings',
					token: User.getToken()
				};
				params['key'] = this.name;
				params['value'] = this.checked ? this.value : (this.value == '1' ? '0' : '1');

				if(this.name == 'preisalarm') {

					if(this.value == 'push') {

						// Gerät für Push-Nachrichten registrieren
						JET.registerPush();

						return;

					} else if(this.value == 'sms') {

						// Wählt der Benutzer SMS, löschen wir die aktuellen Pushtokens
						params['key'] = 'flag_sms';
						params['value'] = '1';

						localStorage['iospushtoken'] = '';
						localStorage['gcmpushtoken'] = '';

					} else {

						// Wählt der Benutzer Email, löschen wir die aktuellen Pushtokens
						params['key'] = 'flag_sms';
						params['value'] = '0';

						localStorage['iospushtoken'] = '';
						localStorage['gcmpushtoken'] = '';

					}

				} 

				// Kein Internet?
				if(!isConnected()) {

					// Feld wieder zurücksetzen
					that.checked = !that.checked;
					// Fehlermeldung anzeigen
					return displayNoConnectionError();
				}

				// API Call
				$.post(JET.backendURL, params).done(function(data) {

					// Aktualisiere User
					User.setData(data.user);					

				}).fail(function(jqXHR) {

					// Feld zurücksetzen
					that.checked = !that.checked;

					// Internet?
					if(isOfflineError(jqXHR)) {
						return displayNoConnectionError();
					}

					// Zeige Fehlermeldung
					UI.alert('<b>Ein Fehler ist aufgetreten!</b><br />Die Daten konnten nicht gespeichert werden.');


				});

			});

			// Klick auf "Speichern", schließt Modal, da die Daten bereits gespeichert wurden.
			JET.on('modal.primary.click.settings', function(e) {
				UI.modalClose();
			});
			
		},
		unbindEvents: function() {
			// Eventhandler löschen
			el.off('.settings');
			JET.off('.settings');
		}
	};

	/**
	 * Rendert den View
	 */
	function render() {

		// Hole Userdaten
		var data = User.getData();

		// Default
		var preisalarm = 'mail';

		if(data.push_token == '1') {
			preisalarm = 'push';
		} else if(data.flag_sms === '1') {
			preisalarm = 'sms';
		}

		var params = {
			preisalarm: preisalarm,
			flag_private: data.flag_private,
			flag_message_notifications: data.flag_message_notifications,
			flag_calendar_reminder: data.flag_calendar_reminder,
			flag_calender_ads: data.flag_calender_ads,
			flag_email_ads: data.flag_email_ads
		};
		
		setTimeout(function() {
			// Setze Formularwerte
			$('#edit-settings').formParams(params)
		}, 1);
		


	}

	return config;

});