JET.controller('KlickeReportUser', function(el) {

	var isTemplateLoaded = false,
		user_id,
		$form;


	var config = {
		title: 'Profil melden',
		template: 'Klicke_report_user.html',
		templateLoaded: function() {

			isTemplateLoaded = true;

			// Cache das Formular
			$form = el.find('#report-user');
			render();
		},
		viewWillAppear: function(_user_id) {

			// Modalbuttontexte setzen
			$('#modal-primary').text('Abschicken');
			$('#modal-secondary').text('Abbrechen');

			// Fehlermeldungen verbergen
			el.find('.error').remove();
			el.find('.is-error').removeClass('is-error');

			// Ohne geht's eigentlich gar nicht!?!?
			if(_user_id) {
				user_id = _user_id;
			}

			if(isTemplateLoaded) {
				render();
			}

		},
		bindEvents: function() {

			// Eventhandler zum Speichern der Daten
			el.on('submit.reportuser', '#report-user', saveForm);
			JET.on('modal.primary.click.reportuser', saveForm);
		},
		unbindEvents: function() {

			// Entferne Eventhandler
			JET.off('.reportuser');
			el.off('.reportuser');

		}
	};

	/**
	 * Rendert den View
	 */
	function render() {

		// Setze Formularwerte
		$form.formParams({
			to_user_id: user_id
		});
	};

	/**
	 * Speichert die Formulardaten
	 * @param e
	 * @returns {*}
	 */
	function saveForm(e) {

		// Formsubmit verhindern
		e.preventDefault();

		// Formulardaten
		var params = $form.formParams();

		// API Parameter
		params.action = 'reportUser';
		params.token = User.getToken();

		// Internet?
		if(!isConnected()) {
			return displayNoConnectionError();
		}

		// Zeige Loading
		UI.toggleLoading();

		// API Call
		$.post(JET.backendURL, params, 'json').done(function(data) {

			// Aktualisiere User
			User.setData(data.user);
			// Schliesse Modal und aktualisiere den darunterliegenden View
			UI.modalClose(true);

		}).fail(function(jqXHR, textStatus, errorThrown) {

			// Internet?
			if(isOfflineError(jqXHR)) {
				return displayNoConnectionError();
			}

			// Zeige Fehlermeldung
			var response = jqXHR.responseJSON || jqXHR.responseText && JSON.parse(jqXHR.responseText) || {msg: "API Fehler " + errorThrown};
			UI.alert('<b>Ein Fehler ist aufgetreten!</b><br />' + response.msg);

		}).always(function() {
			// Verberge Fehlermeldung
			UI.toggleLoading();
		});

	}

	return config;

});