JET.controller('Startseite', function(el) {

	var carousel, slides, isTemplateLoaded = false;	

	var config = {
		//title: '<img src="css/chrome/jet-logo.png">',
        title: '',
		template: 'Startseite.html',
		templateLoaded: function() {

			isTemplateLoaded = true;
			render();

		},
		bindEvents: function() {

			// Erzwinge, das der Backbutton nicht mehr angezeigt wird.
			$('#back-search').addClass('is-search').removeClass('is-back');

			if(isTemplateLoaded) {
				render();
			}

		},
		unbindEvents: function() {
			
			el.off('.startseite');
			carousel.destroy();
			$('.carousel', el).empty().append(slides);
			slides = null;
		}
	};

	function render() {

		var i,
			newel, 
			page, 
			$carousel = $('.carousel', el), 
			
			$indicator = $('#indicator', el),
			lis = [];

		slides = $carousel.find('.slide').detach();

		carousel = new SwipeView($carousel[0], {
			numberOfPages: slides.length,
			hastyPageFlip: true
		});

		for(i=0; i<3; ++i) {
			page = i==0 ? slides.length -1 : i-1;
			
			newel = document.createElement('div');
			newel.className = 'cslide';
			newel.innerHTML = slides[page].outerHTML;

			carousel.masterPages[i].appendChild(newel);
		}

		carousel.onFlip(function() {
			var elem, upcoming, i;
			for(i=0; i<3; ++i) {
				upcoming = carousel.masterPages[i].dataset.upcomingPageIndex;

				if(upcoming != carousel.masterPages[i].dataset.pageIndex) {
					elem = carousel.masterPages[i].querySelector('div.cslide');
					elem.innerHTML = slides[upcoming].outerHTML;
				}
			}

			
			el.find('.is-active').removeClass('is-active');
			$indicator[0].childNodes[carousel.pageIndex].className = 'is-active';
		});

		for(i=0; i<slides.length; ++i) {
			lis.push('<li'+(i==0 ? ' class="is-active"' : '')+'></li>');
		}

		$indicator.html(lis.join(''));

		carousel.refreshSize();

		el.on('click.startseite', '#indicator li', function() {
			carousel.goToPage($(this).index());
		});

	};

	return config;

});