JET.controller('Tankstellenradar', function(el) {

	// Hilfsvariable
	var isTemplateLoaded = false;

	var config = {
		title: 'JET Tankstellenradar',
		template: 'Tankstellenradar.html',
		templateLoaded: function() {

			isTemplateLoaded = true;
			checkButton();

		},
		bindEvents: function() {

			if(isTemplateLoaded) {
				checkButton();
			}

			// Registriere Eventhandler
			el.on('click.tsradar', '.radar-button', function() {

				if(Radar.status() == 'enabled') {
					Radar.disable();
					el.find('.radar-button').removeClass('radar-on').addClass('radar-off');
				} else {
					Radar.enable();
					el.find('.radar-button').removeClass('radar-off').addClass('radar-on');
				}

			});

		},
		unbindEvents: function() {
			// Entferne Eventhandler
			el.off('.tsradar');
		}
	};

	/**
	 * Setzt die CSS-Klasse für den Radar an/aus Button
	 */
	function checkButton() {
		if(Radar.status() == 'enabled') {

			el.find('.radar-button').removeClass('radar-off').addClass('radar-on');

		} else {

			el.find('.radar-button').removeClass('radar-on').addClass('radar-off');

		}
	};

	return config;

});