var ga = (function() {

        // Dürfen wir tracken?
    var doTrack = false,

        // Sind wir soweit?
        isInitialised = false,

        // Alle Events, die vor "startTracking" getätigt wurden
        queue = [];

    /**
     * Starte den Tracker
     * Wird durch das Event "app.ready" ausgelöst.
     */
    function init() {

        // Erlaubnis des Users
        var trackMe = localStorage['trackMe'];

        if (trackMe === '1') {
            startTracking();
        } else if (trackMe === '0') {
            isInitialised = false;
            doTrack = false;
        } else {
            // Wenn er nicht ausdrücklich abgelehnt hat, hat er wohl zugestimmt.
            startTracking();
        }
    };

    // Diese Callbacks haben keine Funktion
    function nativePluginSuccessHandler(result) {
        console.log('GoogleAnalyticsSuccess: ' + result);
    };
    function nativePluginErrorHandler(error) {
        console.log('GoogleAnalyticsError: ' + error);
    };

    function startTracking() {

        navigator.analytics.setTrackingId('UA-28435664-1', function setTrackingIdSuccess() {
            navigator.analytics.setAppOptOut(false, function() {
                // OK, let's go!
                isInitialised = true;
                doTrack = true;
                localStorage['trackMe'] = '1';
                console.log('GoogleAnalyticsSuccess: ' + result);

                navigator.analytics.set('aip', 1);

                // Speichere alle Events, die vor diesem Aufruf aufgelaufen sind.
                for (var i = 0; i < queue.length; ++i) {

                    if (queue[i].type == 'event') {
                        trackEvent(queue[i].name, queue[i].action);
                    } else {
                        trackPage(queue[i].name);
                    }

                }
                ;
                queue = [];
            }, nativePluginErrorHandler);
        }, nativePluginErrorHandler);
      

        
    };

    /**
     * Track ein Event (Belegscanner success)
     */
    function trackEvent(name, action) {

        if (!isInitialised) {
            queue.push({
                type: 'event',
                name: name,
                action: action
            });

            return;
        }

        if (!doTrack) {
            return;
        }

        
        navigator.analytics.sendEvent(name, action);
    }
    ;

    /**
     * Trackt einen Seitenaufruf (Tankstellensuche, Impressum, Profil)
     */
    function trackPage(page) {
        if (!isInitialised) {
            queue.push({
                type: 'page',
                name: page
            });

            return;
        }

        if (!doTrack) {
            return;
        }

        
        navigator.analytics.sendEvent('AppPageView', page);
    }
    ;

    /**
     * Beendet das Plugin, wenn die App in den Hintergrund gelegt wird.
     */
    function exit() {

        if (isInitialised) {
            navigator.analytics.close();
            

        }

    }
    ;

    JET.on('app.ready', init);
    JET.on('app.paused', exit);
    JET.on('view.didAppear', function(e, which) {
        trackPage(which);
    });
    JET.on('modal.didAppear', function(e, which) {
        trackPage(which);
    });



    return {
        init: init,
        exit: exit,
        trackEvent: trackEvent,
        trackPage: trackPage,
        stopTracking: function() {
            localStorage['trackMe'] = '0';
            doTrack = false;
            navigator.analytics.setAppOptOut(true);
        }

    };

})();