/*!
 * jQuery++ - 1.0.1
 * http://jquerypp.com
 * Copyright (c) 2014 Bitovi
 * Sat, 15 Feb 2014 11:53:56 GMT
 * Licensed MIT
 * Download from: http://bitbuilder.herokuapp.com/jquerypp.custom.js?plugins=jquerypp%2Fdom%2Fanimate&plugins=jquerypp%2Fdom%2Fform_params&plugins=jquerypp%2Fevent%2Fdestroyed&plugins=jquerypp%2Fevent%2Ffastfix
 */
(function($) {

    // ## jquerypp/dom/styles/styles.js
    var __m3 = (function($) {
        var getComputedStyle = document.defaultView && document.defaultView.getComputedStyle,
            // The following variables are used to convert camelcased attribute names
            // into dashed names, e.g. borderWidth to border-width
            rupper = /([A-Z])/g,
            rdashAlpha = /-([a-z])/ig,
            fcamelCase = function(all, letter) {
                return letter.toUpperCase();
            },
            // Returns the computed style for an elementn
            getStyle = function(elem) {
                if (getComputedStyle) {
                    return getComputedStyle(elem, null);
                } else if (elem.currentStyle) {
                    return elem.currentStyle;
                }
            },
            // Checks for float px and numeric values
            rfloat = /float/i,
            rnumpx = /^-?\d+(?:px)?$/i,
            rnum = /^-?\d/;

        // Returns a list of styles for a given element
        $.styles = function(el, styles) {
            if (!el) {
                return null;
            }
            var currentS = getStyle(el),
                oldName, val, style = el.style,
                results = {},
                i = 0,
                left, rsLeft, camelCase, name;

            // Go through each style
            for (; i < styles.length; i++) {
                name = styles[i];
                oldName = name.replace(rdashAlpha, fcamelCase);

                if (rfloat.test(name)) {
                    name = $.support.cssFloat ? "float" : "styleFloat";
                    oldName = "cssFloat";
                }

                // If we have getComputedStyle available
                if (getComputedStyle) {
                    // convert camelcased property names to dashed name
                    name = name.replace(rupper, "-$1").toLowerCase();
                    // use getPropertyValue of the current style object
                    val = currentS.getPropertyValue(name);
                    // default opacity is 1
                    if (name === "opacity" && val === "") {
                        val = "1";
                    }
                    results[oldName] = val;
                } else {
                    // Without getComputedStyles
                    camelCase = name.replace(rdashAlpha, fcamelCase);
                    results[oldName] = currentS[name] || currentS[camelCase];

                    // convert to px
                    if (!rnumpx.test(results[oldName]) && rnum.test(results[oldName])) {
                        // Remember the original values
                        left = style.left;
                        rsLeft = el.runtimeStyle.left;

                        // Put in the new values to get a computed value out
                        el.runtimeStyle.left = el.currentStyle.left;
                        style.left = camelCase === "fontSize" ? "1em" : (results[oldName] || 0);
                        results[oldName] = style.pixelLeft + "px";

                        // Revert the changed values
                        style.left = left;
                        el.runtimeStyle.left = rsLeft;
                    }

                }
            }

            return results;
        };


        $.fn.styles = function() {
            // Pass the arguments as an array to $.styles
            return $.styles(this[0], $.makeArray(arguments));
        };

        return $;
    })($);

    // ## jquerypp/dom/animate/animate.js
    var __m1 = (function($) {

        // Overwrites `jQuery.fn.animate` to use CSS 3 animations if possible

        var
        // The global animation counter
        animationNum = 0,
            // The stylesheet for our animations
            styleSheet = null,
            // The animation cache
            cache = [],
            // Stores the browser properties like transition end event name and prefix
            browser = null,
            // Store the original $.fn.animate
            oldanimate = $.fn.animate,

            // Return the stylesheet, create it if it doesn't exists
            getStyleSheet = function() {
                if (!styleSheet) {
                    var style = document.createElement('style');
                    style.setAttribute("type", "text/css");
                    style.setAttribute("media", "screen");

                    document.getElementsByTagName('head')[0].appendChild(style);
                    if (!window.createPopup) {
                        style.appendChild(document.createTextNode(''));
                    }

                    styleSheet = style.sheet;
                }

                return styleSheet;
            },

            //removes an animation rule from a sheet
            removeAnimation = function(sheet, name) {
                for (var j = sheet.cssRules.length - 1; j >= 0; j--) {
                    var rule = sheet.cssRules[j];
                    // 7 means the keyframe rule
                    if (rule.type === 7 && rule.name == name) {
                        sheet.deleteRule(j)
                        return;
                    }
                }
            },

            // Returns whether the animation should be passed to the original $.fn.animate.
            passThrough = function(props, ops, easing, callback) {
                var nonElement = !(this[0] && this[0].nodeType),
                    isInline = !nonElement && $(this).css("display") === "inline" && $(this).css("float") === "none",
                    browser = getBrowser();

                for (var name in props) {
                    // jQuery does something with these values
                    if (props[name] == 'show' || props[name] == 'hide' || props[name] == 'toggle'
                        // Arrays for individual easing
                        || $.isArray(props[name])
                        // Negative values not handled the same
                        || props[name] < 0
                        // unit-less value
                        || name == 'zIndex' || name == 'z-index' || name == 'scrollTop' || name == 'scrollLeft') {
                        return true;
                    }
                }

                return props.jquery === true || browser === null || browser.prefix === '-o-' ||
                // Animating empty properties
                $.isEmptyObject(props) ||
                // We can't do custom easing
                (easing || easing && typeof easing == 'string') ||
                // Second parameter is an object - we can only handle primitives
                $.isPlainObject(ops) ||
                // Inline and non elements
                isInline || nonElement;
            },

            // Gets a CSS number (with px added as the default unit if the value is a number)
            cssValue = function(origName, value) {
                if (typeof value === "number" && !$.cssNumber[origName]) {
                    return value += "px";
                }
                return value;
            },

            // Feature detection borrowed by http://modernizr.com/
            getBrowser = function() {
                if (!browser) {
                    var t,
                        el = document.createElement('fakeelement'),
                        transitions = {
                            'transition': {
                                transitionEnd: 'transitionEnd',
                                prefix: ''
                            },
                            //						'MSTransition': {
                            //							transitionEnd : 'msTransitionEnd',
                            //							prefix : '-ms-'
                            //						},
                            'MozTransition': {
                                transitionEnd: 'animationend',
                                prefix: '-moz-'
                            },
                            'WebkitTransition': {
                                transitionEnd: 'webkitAnimationEnd',
                                prefix: '-webkit-'
                            },
                            'OTransition': {
                                transitionEnd: 'oTransitionEnd',
                                prefix: '-o-'
                            }
                        }

                    for (t in transitions) {
                        if (t in el.style) {
                            browser = transitions[t];
                        }
                    }
                }

                return browser;
            },

            // Properties that Firefox can't animate if set to 'auto':
            // https://bugzilla.mozilla.org/show_bug.cgi?id=571344
            // Provides a converter that returns the actual value
            ffProps = {
                top: function(el) {
                    return el.position().top;
                },
                left: function(el) {
                    return el.position().left;
                },
                width: function(el) {
                    return el.width();
                },
                height: function(el) {
                    return el.height();
                },
                fontSize: function(el) {
                    return '1em';
                }
            },

            // Add browser specific prefix
            addPrefix = function(properties) {
                var result = {};
                $.each(properties, function(name, value) {
                    result[getBrowser().prefix + name] = value;
                });
                return result;
            },

            // Returns the animation name for a given style. It either uses a cached
            // version or adds it to the stylesheet, removing the oldest style if the
            // cache has reached a certain size.
            getAnimation = function(style) {
                var sheet, name, last;

                // Look up the cached style, set it to that name and reset age if found
                // increment the age for any other animation
                $.each(cache, function(i, animation) {
                    if (style === animation.style) {
                        name = animation.name;
                        animation.age = 0;
                    } else {
                        animation.age += 1;
                    }
                });

                if (!name) { // Add a new style
                    sheet = getStyleSheet();
                    name = "jquerypp_animation_" + (animationNum++);
                    // get the last sheet and insert this rule into it
                    sheet.insertRule("@" + getBrowser().prefix + "keyframes " + name + ' ' + style, (sheet.cssRules && sheet.cssRules.length) || 0);
                    cache.push({
                            name: name,
                            style: style,
                            age: 0
                        });

                    // Sort the cache by age
                    cache.sort(function(first, second) {
                        return first.age - second.age;
                    });

                    // Remove the last (oldest) item from the cache if it has more than 20 items
                    if (cache.length > 20) {
                        last = cache.pop();
                        removeAnimation(sheet, last.name);
                    }
                }

                return name;
            };


        $.fn.animate = function(props, speed, easing, callback) {
            //default to normal animations if browser doesn't support them
            if (passThrough.apply(this, arguments)) {
                return oldanimate.apply(this, arguments);
            }

            var optall = $.speed(speed, easing, callback),
                overflow = [];

            // if we are animating height and width properties, set overflow to hidden, and save
            // the previous overflow information to replace with when done.
            if ("height" in props || "width" in props) {
                overflow = [this[0].style.overflow, this[0].style.overflowX, this[0].style.overflowY];
                this.css('overflow', 'hidden');
            }

            // Add everything to the animation queue
            this.queue(optall.queue, function(done) {
                var
                //current CSS values
                current,
                    // The list of properties passed
                    properties = [],
                    to = "",
                    prop,
                    self = $(this),
                    duration = optall.duration,
                    //the animation keyframe name
                    animationName,
                    // The key used to store the animation hook
                    dataKey,
                    //the text for the keyframe
                    style = "{ from {",
                    // The animation end event handler.
                    // Will be called both on animation end and after calling .stop()
                    animationEnd = function(currentCSS, exec) {
                        // As long as we don't stop mid animation, then we will replace
                        // the overflow values of the element being animated.
                        if (!exec) {
                            self[0].style.overflow = overflow[0];
                            self[0].style.overflowX = overflow[1];
                            self[0].style.overflowY = overflow[2];
                        } else {
                            self.css('overflow', '');
                        }

                        self.css(currentCSS);

                        self.css(addPrefix({
                                    "animation-duration": "",
                                    "animation-name": "",
                                    "animation-fill-mode": "",
                                    "animation-play-state": ""
                                }));

                        // Call the original callback
                        if ($.isFunction(optall.old) && exec) {
                            // Call success, pass the DOM element as the this reference
                            optall.old.call(self[0], true)
                        }

                        $.removeData(self, dataKey, true);
                    },
                    finishAnimation = function() {
                        // Call animationEnd using the passed properties
                        animationEnd(props, true);
                        done();
                    };

                for (prop in props) {
                    properties.push(prop);
                }

                if (getBrowser().prefix === '-moz-') {
                    // Normalize 'auto' properties in FF
                    $.each(properties, function(i, prop) {
                        var converter = ffProps[$.camelCase(prop)];
                        if (converter && self.css(prop) == 'auto') {
                            self.css(prop, converter(self));
                        }
                    });
                }

                // Use $.styles
                current = self.styles.apply(self, properties);
                $.each(properties, function(i, cur) {
                    // Convert a camelcased property name
                    var name = cur.replace(/([A-Z]|^ms)/g, "-$1").toLowerCase();
                    style += name + " : " + cssValue(cur, current[cur]) + "; ";
                    to += name + " : " + cssValue(cur, props[cur]) + "; ";
                });

                style += "} to {" + to + " }}";

                animationName = getAnimation(style);
                dataKey = animationName + '.run';

                // Add a hook which will be called when the animation stops
                $._data(this, dataKey, {
                        stop: function(gotoEnd) {
                            // Pause the animation
                            self.css(addPrefix({
                                        'animation-play-state': 'paused'
                                    }));
                            // Unbind the animation end handler
                            self.off(getBrowser().transitionEnd, finishAnimation);
                            if (!gotoEnd) {
                                // We were told not to finish the animation
                                // Call animationEnd but set the CSS to the current computed style
                                animationEnd(self.styles.apply(self, properties), false);
                            } else {
                                // Finish animaion
                                animationEnd(props, true);
                            }
                        }
                    });

                // set this element to point to that animation
                self.css(addPrefix({
                            "animation-duration": duration + "ms",
                            "animation-name": animationName,
                            "animation-fill-mode": "forwards"
                        }));

                // Attach the transition end event handler to run only once
                self.one(getBrowser().transitionEnd, finishAnimation);

            });

            return this;
        };

        return $;
    })($, __m3);

    // ## jquerypp/dom/form_params/form_params.js
    var __m4 = (function($) {
        var
        // use to parse bracket notation like my[name][attribute]
        keyBreaker = /[^\[\]]+/g,
            // converts values that look like numbers and booleans and removes empty strings
            convertValue = function(value) {
                if ($.isNumeric(value)) {
                    return parseFloat(value);
                } else if (value === 'true') {
                    return true;
                } else if (value === 'false') {
                    return false;
                } else if (value === '' || value === null) {
                    return undefined;
                }
                return value;
            },
            // Access nested data
            nestData = function(elem, type, data, parts, value, seen, fullName) {
                var name = parts.shift();
                // Keep track of the dot separated fullname. Used to uniquely track seen values
                // and if they should be converted to an array or not
                fullName = fullName ? fullName + '.' + name : name;

                if (parts.length) {
                    if (!data[name]) {
                        data[name] = {};
                    }

                    // Recursive call
                    nestData(elem, type, data[name], parts, value, seen, fullName);
                } else {

                    // Handle same name case, as well as "last checkbox checked"
                    // case
                    if (fullName in seen && type != "radio" && !$.isArray(data[name])) {
                        if (name in data) {
                            data[name] = [data[name]];
                        } else {
                            data[name] = [];
                        }
                    } else {
                        seen[fullName] = true;
                    }

                    // Finally, assign data
                    if ((type == "radio" || type == "checkbox") && !elem.is(":checked")) {
                        return
                    }

                    if (!data[name]) {
                        data[name] = value;
                    } else {
                        data[name].push(value);
                    }

                }

            };


        $.fn.extend({
                formParams: function(params) {

                    var convert;

                    // Quick way to determine if something is a boolean
                    if ( !! params === params) {
                        convert = params;
                        params = null;
                    }

                    if (params) {
                        return this.setParams(params);
                    } else {
                        return this.getParams(convert);
                    }
                },
                setParams: function(params) {

                    // Find all the inputs
                    this.find("[name]").each(function() {
                        var $this = $(this),
                            value = params[$this.attr("name")];

                        // Don't do all this work if there's no value
                        if (value !== undefined) {

                            // Nested these if statements for performance
                            if ($this.is(":radio")) {
                                if ($this.val() == value) {
                                    $this.attr("checked", true);
                                    this.checked = true;
                                } else {
                                    $this.removeAttr("checked");
                                    this.checked = false;
                                }
                            } else if ($this.is(":checkbox")) {
                                // Convert single value to an array to reduce
                                // complexity
                                value = $.isArray(value) ? value : [value];
                                if ($.inArray($this.val(), value) > -1) {
                                    $this.attr("checked", true);
                                    this.checked = true;
                                } else {
                                    $this.removeAttr("checked");
                                    this.checked = false;
                                }
                            } else {
                                $this.val(value);
                            }
                        }
                    });
                },
                getParams: function(convert) {
                    var data = {},
                        // This is used to keep track of the checkbox names that we've
                        // already seen, so we know that we should return an array if
                        // we see it multiple times. Fixes last checkbox checked bug.
                        seen = {},
                        current;

                    this.find("[name]:not(:disabled)").each(function() {
                        var $this = $(this),
                            type = $this.attr("type"),
                            name = $this.attr("name"),
                            value = $this.val(),
                            parts;

                        // Don't accumulate submit buttons and nameless elements
                        if (type == "submit" || !name) {
                            return;
                        }

                        // Figure out name parts
                        parts = name.match(keyBreaker);
                        if (!parts.length) {
                            parts = [name];
                        }

                        // Convert the value
                        if (convert) {
                            value = convertValue(value);
                        }

                        // Assign data recursively
                        nestData($this, type, data, parts, value, seen);

                    });

                    return data;
                }
            });

        return $;
    })($);

    // ## jquerypp/event/destroyed/destroyed.js
    var __m5 = (function($) {


        // Store the old jQuery.cleanData
        var oldClean = $.cleanData;

        // Overwrites cleanData which is called by jQuery on manipulation methods
        $.cleanData = function(elems) {
            for (var i = 0, elem;
                (elem = elems[i]) !== undefined; i++) {
                // Trigger the destroyed event
                $(elem).triggerHandler("destroyed");
            }
            // Call the old jQuery.cleanData
            oldClean(elems);
        };
        return $;
    })($);

    // ## jquerypp/event/fastfix/fastfix.js
    var __m6 = (function($) {
        // http://bitovi.com/blog/2012/04/faster-jquery-event-fix.html
        // https://gist.github.com/2377196

        // IE 8 has Object.defineProperty but it only defines DOM Nodes. According to
        // http://kangax.github.com/es5-compat-table/#define-property-ie-note
        // All browser that have Object.defineProperties also support Object.defineProperty properly
        if (Object.defineProperties) {
            var
            // Use defineProperty on an object to set the value and return it
            set = function(obj, prop, val) {
                if (val !== undefined) {
                    Object.defineProperty(obj, prop, {
                            value: val
                        });
                }
                return val;
            },
                // special converters
                special = {
                    pageX: function(original) {
                        if (!original) {
                            return;
                        }

                        var eventDoc = this.target.ownerDocument || document;
                        doc = eventDoc.documentElement;
                        body = eventDoc.body;
                        return original.clientX + (doc && doc.scrollLeft || body && body.scrollLeft || 0) - (doc && doc.clientLeft || body && body.clientLeft || 0);
                    },
                    pageY: function(original) {
                        if (!original) {
                            return;
                        }

                        var eventDoc = this.target.ownerDocument || document;
                        doc = eventDoc.documentElement;
                        body = eventDoc.body;
                        return original.clientY + (doc && doc.scrollTop || body && body.scrollTop || 0) - (doc && doc.clientTop || body && body.clientTop || 0);
                    },
                    relatedTarget: function(original) {
                        if (!original) {
                            return;
                        }

                        return original.fromElement === this.target ? original.toElement : original.fromElement;
                    },
                    metaKey: function(originalEvent) {
                        if (!originalEvent) {
                            return;
                        }
                        return originalEvent.ctrlKey;
                    },
                    which: function(original) {
                        if (!original) {
                            return;
                        }

                        return original.charCode != null ? original.charCode : original.keyCode;
                    }
                };

            // Get all properties that should be mapped
            $.each($.event.keyHooks.props.concat($.event.mouseHooks.props).concat($.event.props), function(i, prop) {
                if (prop !== "target") {
                    (function() {
                        Object.defineProperty($.Event.prototype, prop, {
                                get: function() {
                                    // get the original value, undefined when there is no original event
                                    var originalValue = this.originalEvent && this.originalEvent[prop];
                                    // overwrite getter lookup
                                    return this['_' + prop] !== undefined ? this['_' + prop] : set(this, prop,
                                        // if we have a special function and no value
                                        special[prop] && originalValue === undefined ?
                                        // call the special function
                                        special[prop].call(this, this.originalEvent) :
                                        // use the original value
                                        originalValue)
                                },
                                set: function(newValue) {
                                    // Set the property with underscore prefix
                                    this['_' + prop] = newValue;
                                }
                            });
                    })();
                }
            });

            $.event.fix = function(event) {
                if (event[$.expando]) {
                    return event;
                }
                // Create a jQuery event with at minimum a target and type set
                var originalEvent = event,
                    event = $.Event(originalEvent);
                event.target = originalEvent.target;
                // Fix target property, if necessary (#1925, IE 6/7/8 & Safari2)
                if (!event.target) {
                    event.target = originalEvent.srcElement || document;
                }

                // Target should not be a text node (#504, Safari)
                if (event.target.nodeType === 3) {
                    event.target = event.target.parentNode;
                }

                return event;
            }
        }

        return $;
    })($);
})(jQuery);